interface IRetryPolicy {
    retries: number;
    delay?: number;
    backoff?: number;
}
declare class BaseClient {
    protected _headers: {
        [k: string]: string | number | string[];
    };
    protected _retry: IRetryPolicy;
    protected _ttl: number;
    auth(username: string, password: string): this;
    set(leader: string, value: string): this;
    set(leader: {
        [k: string]: string | number | string[];
    }): this;
    timeout(ttl: number): this;
    retry(policy: number): this;
    retry(policy: IRetryPolicy): this;
}
export = BaseClient;
