"use strict";
class BaseClient {
    constructor() {
        this._headers = {};
        this._retry = { retries: 0 };
    }
    auth(username, password) {
        const encoded = Buffer.from(username + ':' + password).toString('base64');
        this.set('Authorization', `Basic ${encoded}`);
        return this;
    }
    set(leader, value) {
        if (typeof leader === 'string') {
            this._headers[leader] = value;
        }
        else {
            Object.keys(leader).forEach((h) => this._headers[h] = leader[h]);
        }
        return this;
    }
    timeout(ttl) {
        this._ttl = ttl;
        return this;
    }
    retry(policy) {
        if (typeof policy === 'number') {
            this._retry = { retries: policy };
        }
        else {
            this._retry = policy;
        }
        return this;
    }
}
module.exports = BaseClient;
