/// <reference types="node" />
import Request = require('./request');
import BaseClient = require('./base-client');
declare class Client extends BaseClient {
    private _prefix;
    private _cert;
    private _key;
    private _ca;
    constructor(prefix: string, headers?: {
        [k: string]: string | number | string[];
    });
    get(path?: string): Request;
    head(path?: string): Request;
    post(path?: string): Request;
    put(path?: string): Request;
    patch(path?: string): Request;
    delete(path?: string): Request;
    del(path?: string): Request;
    cert(certstr: string | Buffer): this;
    key(keystr: string | Buffer): this;
    ca(castrs: Array<string | Buffer>): this;
    private build;
}
export = Client;
