"use strict";
/*
 * Light-weight HTTP client & JSON request class syntactic sugar
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.del = exports.patch = exports.put = exports.post = exports.head = exports.get = exports.Response = exports.Request = exports.RequestError = exports.Client = exports.request = void 0;
const Client = require("./client");
exports.Client = Client;
const RequestError = require("./request-error");
exports.RequestError = RequestError;
const Request = require("./request");
exports.Request = Request;
const Response = require("./response");
exports.Response = Response;
/*
 * Helper functions
 */
function get(url) {
    return new Request('GET', url);
}
exports.get = get;
function head(url) {
    return new Request('HEAD', url);
}
exports.head = head;
function post(url) {
    return new Request('POST', url);
}
exports.post = post;
function put(url) {
    return new Request('PUT', url);
}
exports.put = put;
function patch(url) {
    return new Request('PATCH', url);
}
exports.patch = patch;
function del(url) {
    return new Request('DELETE', url);
}
exports.del = del;
const request = { get, head, post, put, patch, del };
exports.request = request;
// Patch around typescript declaration file issue
exports.delete = del;
