"use strict";
class RequestError extends Error {
    constructor(msg, req, params, res) {
        const attrs = [
            `method=${params.method}`,
            `host=${params.host}`,
            `path=${params.path}`,
            `status=${res ? res.statusCode : 'none'}`,
        ];
        const m = `${msg} ${attrs.join(' ')}${res ? '\n' + res.text : ''}`;
        super(m);
        this.request = req;
        if (res) {
            this.status = res.statusCode;
            this.statusCode = this.status;
            this.response = res;
        }
    }
}
module.exports = RequestError;
