/// <reference types="node" />
import BaseClient = require('./base-client');
import RequestError = require('./request-error');
import Response = require('./response');
declare class Request extends BaseClient implements PromiseLike<Response> {
    private _protocol;
    private _query;
    private _body;
    private _params;
    constructor(method: string, url: string);
    query(arg: string | {
        [k: string]: string | number | boolean;
    }): Request;
    cert(certstr: string | Buffer): this;
    key(keystr: string | Buffer): this;
    ca(castrs: Array<string | Buffer>): this;
    send(body: string | Object): Request;
    attempt(): Promise<Response>;
    promise(): Promise<Response>;
    then(resolve: ((value: Response) => void) | undefined | null, reject: ((err: RequestError) => void) | undefined | null): Promise<any>;
    catch(cb: any): Promise<RequestError | Response>;
    finally(cb: any): Promise<RequestError | Response>;
    end(done: (err: RequestError, res?: Response) => void): void;
}
export = Request;
